"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const change_case_1 = require("change-case");
class ObjectStack {
    constructor(_type, parentFields = []) {
        this.parentFields = parentFields;
        this.seenFields = new Set();
    }
    get name() {
        return this.parentFields
            .map(({ responseName }) => change_case_1.ucFirst(responseName))
            .join('');
    }
    nested(field, type) {
        return new ObjectStack(type, [...this.parentFields, field]);
    }
    fragment(type) {
        return new ObjectStack(type, this.parentFields);
    }
    sawField(field) {
        this.seenFields.add(field.responseName);
    }
    hasSeenField(field) {
        return this.seenFields.has(field.responseName);
    }
}
exports.ObjectStack = ObjectStack;
